unit Main;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  TTapiComponent,
  StdCtrls;

type
  TfrmMain = class(TForm)
    cmdDial: TButton;
    cboPhonebook: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    txtUsername: TEdit;
    txtDomain: TEdit;
    txtPassword: TEdit;
    lstActivity: TListBox;
    cmdDisconnect: TButton;
    Tapi1: TTapi;
    cmdNewEntry: TButton;
    procedure Tapi1Connect(Sender: TObject);
    procedure Tapi1ConnectFail(Error: Longint; ErrorString: string);
    procedure Tapi1Disconnect(Error: Longint; ErrorString: string);
    procedure Tapi1Notify(Error: Longint; ErrorString: string);
    procedure cmdDialClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdNewEntryClick(Sender: TObject);
    procedure cmdDisconnectClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.Tapi1Connect(Sender: TObject);
begin
  cmdDisconnect.Enabled := True;
end;

procedure TfrmMain.Tapi1ConnectFail(Error: Longint; ErrorString: string);
begin
  MessageDlg('Connection Failed!', mtError, [mbOK], 0);
  cmdDial.Enabled := true;
end;

procedure TfrmMain.Tapi1Disconnect(Error: Longint; ErrorString: string);
begin
  Tapi1.Disconnect;
  cmdDial.Enabled := true;
  cmdDisconnect.Enabled := False;
end;

procedure TfrmMain.Tapi1Notify(Error: Longint; ErrorString: string);
begin
  lstActivity.Items.Add(ErrorString + ' (' + IntToStr(Error) + ')');
  lstActivity.ItemIndex := lstActivity.Items.Count;
end;

procedure TfrmMain.cmdDialClick(Sender: TObject);
begin
  With Tapi1 do
  begin
    EntryName := cboPhonebook.Text;
    Username := txtUsername.Text;
    Domain := txtDomain.Text;
    Password := txtPassword.Text;
  end;
  Try
  begin
    Tapi1.Connect;
    cmdDial.Enabled := False;
  end;
  except
    on E: Exception do
      MessageDlg('An error occurred: ' + E.Message, mtError, [mbOK], 0);
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  if (Tapi1.RasInitialized) then
    cboPhonebook.Items.Assign(Tapi1.PhonebookEntries)
  else
  begin
    MessageDlg('RAS could not be initialized!', mtError, [mbOK], 0);
    cboPhonebook.Enabled := False;
    txtUsername.Enabled := False;
    txtDomain.Enabled := False;
    txtPassword.Enabled := False;
    cmdDial.Enabled := False;
    cmdDisconnect.Enabled := False;
  end;
end;

procedure TfrmMain.cmdNewEntryClick(Sender: TObject);
var
  RetVal: DWord;
begin
  Tapi1.RasCreateEntry(Self.Handle, RetVal);
end;

procedure TfrmMain.cmdDisconnectClick(Sender: TObject);
begin
  Tapi1.Disconnect;
  cmdDial.Enabled := true;
  cmdDisconnect.Enabled := False;
end;

end.
